var wmiInterface = GetObject("winmgmts:{impersonationLevel=impersonate}!//./root/cimv2");
var SpeedFan = GetLibrary();
var SpeedFanEnable = true

if( SpeedFan.GetTemperatureCount() == 0)
	SpeedFanEnable = false;

// } catch(err) { SpeedFanEnable = false; }

System.Gadget.onSettingsClosing = SettingsClosing;

function init() {
	data = wmiInterface.ExecQuery("Select Name From Win32_PerfFormattedData_Tcpip_NetworkInterface WHERE name LIKE '%Ethernet%' or name LIKE '%Wireless%'");
	dataEnum = new Enumerator(data);
	dataEnum.moveFirst();
	while(!dataEnum.atEnd()){
		if(dataEnum.item() != null && dataEnum.item().Name){
			NetworkWatch.add( new Option(dataEnum.item().Name) );
		}
		dataEnum.moveNext();
	}
	if(SpeedFanEnable) {
		updateTemps();
		for(i = 0; i < numCores; i++){
			document.getElementById("Core"+i+"Index").value = parseInt(System.Gadget.Settings.readString("Core"+i+"TempIndx"));
		}
	}
	NetworkWatch.value = System.Gadget.Settings.readString("AdapterName");
	var themeColor = System.Gadget.Settings.readString("ThemeColor");
	if( themeColor.length > 0 ){
		bgSample.style.backgroundColor = "#" + themeColor;
		BackColor.value = themeColor;
	} else {
		BackColor.value = "000055";
		bgSample.style.backgroundColor = "#000055";
	}
}

function SettingsClosing(event){
	debugLog("##SettingsClosing##");
	if (event.closeAction == event.Action.commit) {
		for(i = 0; i < numCores && SpeedFanEnable; i++){
			System.Gadget.Settings.writeString("Core"+i+"TempIndx", document.getElementById("Core"+i+"Index").value);
		}
		System.Gadget.Settings.writeString("AdapterName", NetworkWatch.value);
		System.Gadget.Settings.writeString("ThemeColor", BackColor.value);
	}
	event.cancel = false;
}

function updateTemps(){
	try {
		SpeedFan.Refresh();
		for (var t = 0;t < SpeedFan.GetTemperatureCount();t++) {
			for(i = 0; i < numCores; i++){
				document.getElementById("Core"+i+"Index").options.add(new Option("Temp"+(t+1)+": " + SpeedFan.GetTemperature(t) +  "C",t));
			}
		}
	} catch(err) {debugLog(err)}
}
function unload(){
	debugLog("####SettingsUnloaded####");
}

var currentTab = 'settings';
function ChangeTab(elem, tabName){
	// set the class for the tab button
	if(elem.className == 'tabButton Inactive') {
		elem.className = 'tabButton Active';
		
		var curTabBut = document.getElementById( currentTab + 'Button' );
		if(curTabBut)
			curTabBut.className = "tabButton Inactive";
		var curTab = document.getElementById(currentTab + 'Tab');
		if(curTab)
			curTab.style.display = 'none';
		var tabContent = document.getElementById(tabName + 'Tab');
		if(tabContent){
			tabContent.style.display = 'block';
		}
		currentTab = tabName;
	}
}

function ToggleItem(elem, itemID){
	var thisItem = document.getElementById(itemID);
	if(!thisItem){
		//alert("Error finding '"+itemID+"' symbol!");
		return;
	}
	if(thisItem.style.display == "none"){
		thisItem.style.display = "block";
		elem.value = "Hide";
	} else {
		thisItem.style.display = "none";
		elem.value = "Show";
	}
}
